#include <amxmodx>
#include <reapi>
#include <fakemeta>
#include <xs>

#define PLUGIN "CS Revo: Menu de danças e animações"
#define VERSION "1.0"
#define AUTHOR "Wilian M. | b0t."

#define PREFIX_MENUS "\r[\wCS Revo!\r]"

stock const MODEL_ANIMATION[] = "models/csr_animations.mdl"
stock const g_szCamPrecache[] = "models/rpgrocket.mdl";
stock const ATTACK_BTN = IN_ATTACK|IN_ATTACK2|IN_RELOAD;

#define var_ent_model var_impulse

enum _:XYZ {
	Float:X,Float:Y,Float:Z
};

enum _:eDataDances
{
	eDanceName[32], eDanceSequence
}

new const xDances[][eDataDances] =
{
	{ "Dancinha batendo no bumbum", 0 },
	{ "Dancinha do defante", 1 },
	{ "Dancinha do robô", 2 },
	{ "Mãozinho pro lado", 3 },
	{ "Sentado", 5 },
	{ "Sentado no chão", 6 },
	{ "Meditando", 7 },
	{ "Flexão", 8 },
	{ "Apontando o braço", 9 },
	{ "Deitado no chão", 10 },
	{ "Dando xauzinho", 11 },
	{ "Pulando de alegria", 12 },
	{ "Rindo da cara do inimigo", 13 },
	{ "Mandando beijinho", 14 },
	{ "Olimpíadas", 15 },
	{ "Se rendido", 16 },
	{ "Sentado algemado", 17 },
	{ "Procurando briga", 18 },
	{ "Não", 19 },
	{ "Samurai taichi", 20 },
	{ "Por favor, não me mate", 21 },
	{ "Acenando", 22 },
	{ "Se rendido na parede", 23 },
}

new p_iEntityId[33], p_iCamId[33], iCamIndex

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	xRegisterSay("dance", "xMenuDance")
	xRegisterSay("danca", "xMenuDance")
	xRegisterSay("anim", "xMenuDance")
}

public plugin_precache()
{
	precache_model(MODEL_ANIMATION)
	iCamIndex = precache_model(g_szCamPrecache)
}

public xMenuDance(id)
{
	new xFmtx[128]
	formatex(xFmtx, charsmax(xFmtx), "%s \wMenu de animações e danças", PREFIX_MENUS)
	new xMenu = menu_create(xFmtx, "_xMenuDance")

	new numToStr[10]

	for(new i = 0; i < sizeof(xDances); i++)
	{
		num_to_str(xDances[i][eDanceSequence], numToStr, charsmax(numToStr))
		menu_additem(xMenu, xDances[i][eDanceName], numToStr)
	}
	
	menu_setprop(xMenu, MPROP_NEXTNAME, "Próximo")
	menu_setprop(xMenu, MPROP_BACKNAME, "Voltar")
	menu_setprop(xMenu, MPROP_EXITNAME, "Sair")
	menu_display(id, xMenu)
}

public _xMenuDance(id, menu, item)
{
	if(!is_user_connected(id))
		return PLUGIN_HANDLED

	if(item == MENU_EXIT)
		return PLUGIN_HANDLED

	new xInfo[10]
	menu_item_getinfo(menu, item, _, xInfo, charsmax(xInfo))
	
	xCreateAnimModels(id, MODEL_ANIMATION, str_to_num(xInfo), 1.0);
	xMenuDance(id)

	return PLUGIN_HANDLED
}

public xCreateAnimModels(const id, const szModel[], const iSequence, const Float:fFrameRate)
{
	xRemoveModel(p_iEntityId[id])
	xRemoveCam(p_iCamId[id])

	new iEnt = rg_create_entity("info_target")
	new iEntModel = rg_create_entity("info_target")

	if(is_nullent(iEnt) || is_nullent(iEntModel))
		return

	new Float:fOrigin[XYZ], Float:fMins[XYZ], Float:fAngles[XYZ]
	get_entvar(id, var_origin, fOrigin)
	get_entvar(id, var_mins, fMins)

	fMins[X] = fOrigin[X]
	fMins[Y] = fOrigin[Y]
	fMins[Z] += fOrigin[Z]

	engfunc(EngFunc_SetModel, iEnt, szModel)
	set_entvar(iEnt, var_movetype, MOVETYPE_FLY)
	set_entvar(iEnt, var_ent_model, iEntModel)
	set_entvar(iEnt, var_owner, id)

	p_iEntityId[id] = iEnt

	set_entvar(iEntModel, var_movetype, MOVETYPE_FOLLOW)
	set_entvar(iEntModel, var_aiment, iEnt)

	set_entvar(iEnt, var_framerate,fFrameRate)
	set_entvar(iEnt, var_sequence, iSequence)

	get_entvar(id, var_angles, fAngles)
	fAngles[X] = 0.0

	set_entvar(iEnt, var_angles, fAngles)

	engfunc(EngFunc_SetOrigin, iEnt, fMins)
	engfunc(EngFunc_SetOrigin, iEntModel, fMins)

	new getModel[128]
	get_user_info(id, "model", getModel, charsmax(getModel))
	engfunc(EngFunc_SetModel, iEntModel, fmt("models/player/%s/%s.mdl", getModel, getModel))

	set_entvar(iEntModel, var_body, get_entvar(id,var_body))
	set_entvar(iEntModel, var_skin, get_entvar(id,var_skin))

	set_entvar(iEnt, var_nextthink, get_gametime())
	SetThink(iEnt, "CBaseModel_Think_Post")

	rg_set_user_invisibility(id, true)

	new iEntCam = rg_create_entity("trigger_camera")

	if(is_nullent(iEntCam))
		return
	
	set_entvar(iEntCam, var_modelindex, iCamIndex)
	set_entvar(iEntCam, var_owner, id)
	set_entvar(iEntCam, var_movetype, MOVETYPE_NOCLIP)
	set_entvar(iEntCam, var_rendermode, kRenderTransColor)

	engset_view(id, iEntCam)

	set_entvar(iEntCam, var_nextthink, get_gametime() + 0.01)
	SetThink(iEntCam, "CBaseCam_Think_Post")

	p_iCamId[id] = iEntCam
}

public CBaseModel_Think_Post(const iEnt)
{
	if(is_nullent(iEnt))
	{
		SetThink(iEnt,"")
		return
	}

	static id
	id = get_entvar(iEnt,var_owner)

	if(!is_user_connected(id) || get_entvar(id, var_button) & ATTACK_BTN || !rg_get_user_invisibility(id))
	{
		xRemoveModel(iEnt)
		SetThink(iEnt,"")
		return
	}

	static Float:fOriginId[XYZ], Float:fMins[XYZ], Float:fOriginEnt[XYZ]
	get_entvar(id, var_origin, fOriginId)
	get_entvar(iEnt, var_origin, fOriginEnt)

	get_entvar(id,var_mins,fMins)
	fMins[X] = fOriginId[X]
	fMins[Y] = fOriginId[Y]
	fMins[Z] += fOriginId[Z]

	if(!xs_vec_equal(fMins, fOriginEnt))
	{
		xRemoveModel(iEnt)
		SetThink(iEnt, "")
		return
	}

	set_entvar(iEnt, var_nextthink, get_gametime())
}

public CBaseCam_Think_Post(const iEnt)
{
	if(is_nullent(iEnt))
	{
		SetThink(iEnt,"")
		return
	}

	static id
	id = get_entvar(iEnt, var_owner)

	if(!is_user_connected(id) || !p_iEntityId[id])
	{
		xRemoveCam(iEnt)
		SetThink(iEnt,"")
		return
	}

	new Float:flPlayerOrigin[XYZ], Float:flCamOrigin[XYZ], Float:flVecPlayerAngles[XYZ], Float:flVecCamAngles[XYZ]

	get_entvar(id, var_origin, flPlayerOrigin)
	get_entvar(id, var_view_ofs, flVecPlayerAngles)

	flPlayerOrigin[Z] += flVecPlayerAngles[Z]

	get_entvar(id, var_v_angle, flVecPlayerAngles)
	angle_vector(flVecPlayerAngles, ANGLEVECTOR_FORWARD, flVecCamAngles)
	xs_vec_sub_scaled(flPlayerOrigin, flVecCamAngles, float(150), flCamOrigin)

	engfunc(EngFunc_TraceLine, flPlayerOrigin, flCamOrigin, IGNORE_MONSTERS,id,0)

	new Float:flFraction
	get_tr2(0, TR_flFraction, flFraction)

	xs_vec_sub_scaled(flPlayerOrigin, flVecCamAngles, flFraction * float(150),flCamOrigin)

	set_entvar(iEnt, var_origin, flCamOrigin)
	set_entvar(iEnt, var_angles, flVecPlayerAngles)

	set_entvar(iEnt,var_nextthink, get_gametime() + 0.01)
}

public xRemoveModel(const iEnt)
{
	if(!is_nullent(iEnt))
	{
		new id = get_entvar(iEnt,var_owner)

		if(is_user_connected(id))
		{
			p_iEntityId[id] = 0
			rg_set_user_invisibility(id,false)
		}

		if(get_entvar(iEnt,var_ent_model) != 0)
			set_entvar(get_entvar(iEnt,var_ent_model), var_flags, FL_KILLME)

		set_entvar(iEnt, var_flags, FL_KILLME)
	}
}

public xRemoveCam(const iEnt)
{
	if(!is_nullent(iEnt))
	{
		new id = get_entvar(iEnt,var_owner)

		if(is_user_connected(id))
		{
			p_iCamId[id] = 0
			engset_view(id, id)
		}

		set_entvar(iEnt, var_flags, FL_KILLME)
	}
}

stock xRegisterSay(const xSay[], const xFunc[])
{
	static xFmtx[64]

	formatex(xFmtx, charsmax(xFmtx), "say /%s", xSay)
	register_clcmd(xFmtx, xFunc)
	
	formatex(xFmtx, charsmax(xFmtx), "say .%s", xSay)
	register_clcmd(xFmtx, xFunc)
	
	formatex(xFmtx, charsmax(xFmtx), "say_team /%s", xSay)
	register_clcmd(xFmtx, xFunc)
	
	formatex(xFmtx, charsmax(xFmtx), "say_team .%s", xSay)
	register_clcmd(xFmtx, xFunc)
}

stock rg_set_user_invisibility(const id, bool:bToggle = true) {
	new iEffects = get_entvar(id,var_effects);
	set_entvar(id,var_effects,bToggle ? (iEffects |= EF_NODRAW) : (iEffects &= ~EF_NODRAW))
}

stock bool:rg_get_user_invisibility(const id) {
	return bool:(get_entvar(id, var_effects) & EF_NODRAW);
}